/*
 *  emiter.cpp
 *  smoke
 *
 *  Created by CBreak on Wed May 18 2005.
 *  Copyright (c) 2005 __MyCompanyName__. All rights reserved.
 *
 */

#include "emitter.h"
#include "world.h"

#include <assert.h>

// Creation
Emitter::Emitter()
{
	emissionRate = 40;
	idleTime = 0;
	myWorld = 0;
	s.x = 0; s.y = 0; s.z = 0;
}

Emitter::Emitter(World * theWorld)
{
	emissionRate = 40;
	idleTime = 0;
	myWorld = theWorld;
	s.x = 0; s.y = 0; s.z = 0;
}

void Emitter::setPos(vec3f p)
{
	s = p;
}

void Emitter::emitt(float t)
{
	if (myWorld != 0)
	{
		idleTime += t;
		int particleCount = (int)floor(idleTime*emissionRate);
		if (particleCount > 0)
		{
			idleTime = 0;
			for (int i = 0; i < particleCount; i++)
			{
				// To Do: Consider Emitter Parameters like Direction, emission angle and initial speed.
				Particle * tempP = new Particle(s.x+(float)rand()/RAND_MAX*16-8,
												s.y,
												s.z+(float)rand()/RAND_MAX*16-8,
												myWorld->getCam());
				myWorld->addParticle(tempP);
			}
		}
	}
}

void Emitter::setRate(float newEmissionRate)
{
	emissionRate = newEmissionRate;
}

