/*
 *  forcefield.cpp
 *  smoke
 *
 *  Created by CBreak on Wed May 11 2005.
 *  Copyright (c) 2005 __MyCompanyName__. All rights reserved.
 *
 */

#include "forcefield.h"

GForce::GForce()
{
	g = -9.806694;
}

GForce::GForce(float acceleration)
{
	g = acceleration;
}

// Get the Force
vec3f GForce::getForceAtPoint(float x, float y, float z) const
{
	vec3f tVec = getNextForceAtPoint(x,y,z);
	tVec.y += g;
	return tVec;
}


TForce::TForce()
{
	a = 1;
	n.x = 0; n.y = 1; n.z = 0;
}

TForce::TForce(float acceleration)
{
	a = acceleration;
	n.x = 0; n.y = 1; n.z = 0;	
}

TForce::TForce(float acceleration, vec3f normal)
{
	a = acceleration;
	n = normal;
}

vec3f TForce::getForceAtPoint(float x, float y, float z) const
{
	vec3f tVec = getNextForceAtPoint(x,y,z);
	// f = r x p, the force is the cross product of position and the tornado normal, untested
	tVec.x += (y*n.z - z*n.y)*a;
	tVec.y += (z*n.x - x*n.z)*a;
	tVec.z += (x*n.y - y*n.x)*a;
	return tVec;
}

