/*
 *  particle.h
 *  smoke
 *
 *  Created by CBreak on Wed May 04 2005.
 *  Copyright (c) 2005 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef _Smoke_particle_h_
#define _Smoke_particle_h_

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoTriangleStripSet.h>
#include <Inventor/nodes/SoPointSet.h>
#include <Inventor/nodes/SoCamera.h>

#include "types.h"

struct Particle : public SoSeparator
{
	vec3f s; // Position
	vec3f v; // Velocity
	vec3f a; // Acceleration
	
	float age;

	SoTransform * particleTransform;
	SoMaterial * particleMaterial;
//	SoCamera * myCam;
	
public:
	// Management
	Particle();
	Particle(float x, float y, float z);
	Particle(float x, float y, float z, SoCamera * cam);
	~Particle();
	
	// Animation
	void move(float timestep);
	void adjustAcceleration(float fx, float fy, float fz); // with force
	void adjustAcceleration(vec3f f); // with force
	void interactWith(Particle * p);

	// Accessors
	vec3f getPosition();
	
	// Debug
	void print();
	
private:
	inline void commonInit();
	inline void inventorInit();
};

#endif
