/*
 *  virtualforcefield.cpp
 *  smoke
 *
 *  Created by CBreak on Wed May 11 2005.
 *  Copyright (c) 2005 __MyCompanyName__. All rights reserved.
 *
 */

#include "virtualforcefield.h"

VirtualForcefield::VirtualForcefield()
{
	nextField = 0;
}

VirtualForcefield::~VirtualForcefield()
{
	if (nextField != 0)
		delete nextField;
}

void VirtualForcefield::attachField(VirtualForcefield * aField)
{
	if (nextField != 0)
		nextField->attachField(aField);
	else
		nextField = aField;
}

// Get the Force
vec3f VirtualForcefield::getForceAtPoint(vec3f p) const
{
	return getForceAtPoint(p.x, p.y, p.z);
}

vec3f VirtualForcefield::getForceAtPoint(float x, float y, float z) const
{
	return getNextForceAtPoint(x,y,z);
}

vec3f VirtualForcefield::getNextForceAtPoint(float x, float y, float z) const
{
	vec3f tVec;
	if (nextField != 0)
		tVec = nextField->getForceAtPoint(x,y,z);
	else
	{
		tVec.x = 0;
		tVec.y = 0;
		tVec.z = 0;
	}
	return tVec;
}

void VirtualForcefield::update(float t)
{
	// No change	
}
