/*
 *  world.h
 *  smoke
 *
 *  Created by CBreak on Sat May 07 2005.
 *  Copyright (c) 2005 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef _Smoke_world_h_
#define _Smoke_world_h_

#include <vector>
#include <map>

#include "particle.h"
#include "forcefield.h"
#include "emitter.h"
#include "movingEmitter.h"
#include "dragEmitter.h"

#include <Inventor/sensors/SoTimerSensor.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransformSeparator.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>

using namespace std;
typedef multimap<int,Particle*> ppMap;
typedef enum {running, paused} activityStates;

class World
{
	vector<Particle*> * particles;
	
	SoSeparator * root;
	SoCamera * cam;
	SoTransformSeparator * part; // Particle Group

	VirtualForcefield * theForce;
	DragEmitter * theEmitter;

	// Time management
	SoTimerSensor * tSensor;
    float thisMove, lastMove;

	activityStates state;
	bool interact;

public:
	World();
	~World();
	// Accessors
	SoSeparator * getRoot();
	SoCamera * getCam();
	void addParticle(Particle * someThing);
	int hash (int i, int j, int k);
	int hash (vec3f v);

	// Management
	void resetParticles();
	void resetForces();
	// Forces
	void addTForce();
	void addGForce();
	// Physic
	void toggleInteraction();
	// Emitter
	void setEmissionRate(float newRate);

	// Animation
	void move();
	void toggle();
	void pause();
	void run();
};

// functions
void idleCallback(void * data, SoSensor * sensor);

#endif
